package com.dcoupon_sdk_flutter_plugin;

import java.util.HashMap;
import java.util.Map;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/** DcouponSdkFlutterPlugin */
public class DcouponSdkFlutterPlugin implements MethodCallHandler {
  /** Plugin registration. */
  static MethodChannel channel;
  private String email, clientApiToken, alias, gender, birthdate, externalId;
  public static void registerWith(Registrar registrar) {
    channel = new MethodChannel(registrar.messenger(), "dcoupon_sdk_flutter_plugin");
    channel.setMethodCallHandler(new DcouponSdkFlutterPlugin());
  }

  @Override
  public void onMethodCall(MethodCall call, Result result) {
    System.out.println("ANDROID.DcouponSdkFlutterPlugin.onMethodCall.method -> " + call.method);
    if (call.method.equals("startTest")) {
      System.out.println("ANDROID.DcouponSdkFlutterPlugin.startTest - Starting test...");
      email = call.argument(Constants.EMAIL);
      externalId = call.argument(Constants.EXTERNAL_ID);
      alias = call.argument(Constants.ALIAS);
      gender = call.argument(Constants.GENDER);
      birthdate = call.argument(Constants.BIRTHDATE);
      try {
        Map<String, String> map = new HashMap<String, String>();
        map.put(Constants.EMAIL, email);
        map.put(Constants.EXTERNAL_ID, externalId);
        map.put(Constants.ALIAS, alias);
        map.put(Constants.GENDER, gender);
        map.put(Constants.BIRTHDATE, birthdate);
        map.put(Constants.CLIENT_API_TOKEN, "cfc0p054yw5kguf1sn8a");//from meta-data Android
        invokeMethod(Constants.LOGIN, map);
      } catch (Exception ex) {
        ex.printStackTrace();
      }
    } else {
      result.notImplemented();
    }
  }
  public void invokeMethod(final String method, Map<String, String> map) {
    System.out.println("ANDROID.DcouponSdkFlutterPlugin.invokeMethod." + method + " -> start");
    // from Android to Dart
    if (method == null || method.isEmpty()) {
      System.out.println("missed method name");
      return;
    }
    channel.invokeMethod(method, map, new Result() {
      @Override
      public void success(Object o) {
        System.out.println("ANDROID.DcouponSdkFlutterPlugin.invokeMethod." + method + " -> success");
        try {
          System.out.println(o.toString());
          Map<String, Object> map = (HashMap<String, Object>) o;
          //special to show legaldocs
        } catch (Exception ex) {
          ex.printStackTrace();
        }
      }

      @Override
      public void error(String s, String s1, Object o) {
        System.out.println("ANDROID.DcouponSdkFlutterPlugin.invokeMethod." + method + " -> error");
        System.out.println(s + " - " + s1);
      }

      @Override
      public void notImplemented() {
        System.out.println("Not implemented");
      }
    });
  }
}
