import 'dart:async';

import 'constants.dart';
import 'httprequest.dart';

class HttpAcceptEnrollment extends HttpRequest {
  String jwt,
      alias,
      birthdate,
      gender,
      clientApiToken,
      email,
      externalId,
      legalDocumentsAccepted;
  StreamController<HttpResponse> streamController;

  HttpAcceptEnrollment(
      String jwt,
      String email,
      String alias,
      String birthdate,
      String gender,
      String clientApiToken,
      String legaldocumentsAccepted,
      String url) {
    this.jwt = jwt;
    this.email = email;
    this.alias = alias;
    this.birthdate = birthdate;
    this.gender = gender;
    this.clientApiToken = clientApiToken;
    this.externalId = externalId;
    this.legalDocumentsAccepted = legalDocumentsAccepted;
    setMethod(HttpInterface.POST);
    setUrl(url);
  }

  void onPreExecute() {
    properties = new Map();
    properties.putIfAbsent(Constants.CONTENT_TYPE, () => Constants.JSON_UTF_8);
    properties.putIfAbsent(Constants.CLIENT_API_TOKEN, () => clientApiToken);
    payload = new Map();
    payload.putIfAbsent(Constants.JWT, () => jwt);
    payload.putIfAbsent(Constants.EMAIL, () => email);
    payload.putIfAbsent(Constants.EXTERNAL_ID, () => externalId);
    payload.putIfAbsent(Constants.ALIAS, () => alias);
    payload.putIfAbsent(Constants.GENDER, () => gender);
    payload.putIfAbsent(Constants.BIRTHDATE, () => birthdate);
    payload.putIfAbsent(
        Constants.LEGAL_DOCUMENTS_ACCEPTED, () => legalDocumentsAccepted);
  }

  void onPostExecute(HttpResponse httpResponse) {
    streamController.sink.add(httpResponse);
  }

  void setStreamController(StreamController streamController) {
    this.streamController = streamController;
  }
}
