import 'dart:async';

import 'constants.dart';
import 'httprequest.dart';


class HttpEnrollmentForm extends HttpRequest {
  String clientApiToken;
  StreamController<HttpResponse> streamController;

  HttpEnrollmentForm(String clientApiToken, String url) {
    this.clientApiToken = clientApiToken;
    setMethod(HttpInterface.GET);
    setUrl(url);
  }

  void onPreExecute() {
    properties = new Map();
    properties.putIfAbsent(Constants.CONTENT_TYPE, () => Constants.JSON_UTF_8);
    properties.putIfAbsent(Constants.CLIENT_API_TOKEN, () => clientApiToken);
  }

  void onPostExecute(HttpResponse httpResponse) {
    streamController.sink.add(httpResponse);
  }

  void setStreamController(StreamController streamController) {
    this.streamController = streamController;
  }
}
