import 'dart:async';

import 'httprequest.dart';
import 'constants.dart';


class HttpLogin extends HttpRequest {
  String email, clientApiToken, alias, gender, birthdate, externalId;
  StreamController<HttpResponse> streamController;

  HttpLogin(String email, String clientApiToken, String externalId,
      String alias, String gender, String birthdate, String url) {
    this.email = email;
    this.clientApiToken = clientApiToken;
    this.alias = alias;
    this.gender = gender;
    this.birthdate = birthdate;
    this.externalId = externalId;
    setMethod(HttpInterface.POST);
    setUrl(url);
  }

  void onPreExecute() {
    properties = new Map();
    properties.putIfAbsent(Constants.CONTENT_TYPE, () => Constants.JSON_UTF_8);
    properties.putIfAbsent(Constants.CLIENT_API_TOKEN, () => clientApiToken);
    payload = new Map();
    payload.putIfAbsent(Constants.EMAIL, () => email.toString());
    payload.putIfAbsent(Constants.EXTERNAL_ID, () => externalId);
  }

  void onPostExecute(HttpResponse httpResponse) {
    streamController.sink.add(httpResponse);
  }

  void setStreamController(StreamController streamController) {
    this.streamController = streamController;
  }
}
